#include "bmc.h"
#include "bmc.h"

/********************************************************************/
LOCAL extern OPT op0;
LOCAL extern int PAR_tm;
LOCAL extern time_t t0,t1;
/********************************************************************/
#define mreturn(r)	{op0.opb.bound=k;return r;}
#define prverdstmp()    {sprintf(fn,".verds_%i.%3i",bv,k);}
#define tout            (PAR_tm&&(int)difftime(time(&t1),t0)>PAR_tm)
#define message(s)    	{fprintf(stdout,"INFO:       applying %s\n",s);}
/********************************************************************/
int bmc(tree *spec,tree *prog,tree *fness,tree *varconstr,int booln)
{
	int r;
	tree *p=spec;

        if (op0.bs==8) {
	if ((TLFisLTL(p)||TLFisACTLx(p)||TLFisECTLx(p)))
		op0.bs=2; else 
			/* op0.bs=3; some error with this algorithm */
			op0.bs=1; /* uses pure sat-based algorithm */
	}

	switch (op0.bs) {
		case 1: r=checksolver(op0.opb.qbfsolver,"QBFSOLVER");
			if (r==0) op0.opb.qbfsolver=NULL;
		case 3: r=checksolver(op0.opb.satsolver,"SATSOLVER");
			if (r==0) op0.opb.satsolver=NULL;
			r=qbfbmc(spec,prog,fness,varconstr,booln); 
			return r;
		case 2: r=checksolver(op0.opb.satsolver,"SATSOLVER");
			if (r==0) op0.opb.satsolver=NULL;
			if ((TLFisLTL(p)||TLFisACTLx(p))) {
				r=satbmc(spec,prog,fness,varconstr,booln); 
				return r;
			} else if ((TLFisECTLx(p))) {
				r=satbmcECTLx(spec,prog,fness,varconstr,booln); 
				return r;
			} 
			fprintf(stdout,"ERROR:      invalid options\n"); 
			op0.opb.bound=0; return 0;
	}
}
/********************************************************************/
int qbfbmc(tree *spec,tree *prog,tree *fness,tree *varconstr,int booln)
{
	int i,k,r,bv;
	qmdata *qm;
	qinfo *qi;
	char fn[100];
	FILE *g;
	model *mm0;

	if (op0.bs==1) {
		if (op0.opb.qbfsolver==NULL) { message("an internal QBF-solver"); }
		else if (strcmp(op0.opb.qbfsolver,"_")) { message(op0.opb.qbfsolver); }
	} else /*=3*/ {
		if (op0.opb.satsolver==NULL) { message("an internal SAT-solver"); }
		else if (strcmp(op0.opb.satsolver,"_")) { message(op0.opb.satsolver); }
	}

	for (r=0,k=op0.opb.lbound;k<=op0.opb.bound;k++) {
	    for (bv=1;bv>=0;bv--) {
		if (tout) mreturn(r);
		qi=(qinfo *)calloc(1,sizeof(qinfo));
		qm=bp2q(qi,prog,fness,spec,booln,k,bv);
		if (op0.opb.qbfsolver==NULL||strcmp(op0.opb.qbfsolver,"_")) {
                        i=md2treetype(qm);
                        if (i==1&&op0.bs==3) {
                                mm0=qmd2model(mdnegate(qm),qi);
                                if (bv==1) r=SOLVEapply(op0.opb.satsolver,mm0,bv);
                                else r=-SOLVEapply(op0.opb.satsolver,mm0,!bv);
                                free(mm0->mstring); free(mm0);
                        } else if (i==2&&op0.bs==3) {
                                mm0=qmd2model(qm,qi);
                                if (bv==0) r=SOLVEapply(op0.opb.satsolver,mm0,bv);
                                else r=-SOLVEapply(op0.opb.satsolver,mm0,!bv);
                                free(mm0->mstring); free(mm0);
                        } else {
                                r=SOLVEapplyq(op0.opb.qbfsolver,qm,qi,bv);
                        }
		} else {
                	prverdstmp(); stringreplacechar(fn,' ','0');
                	g=fopen(fn,"w"); qmdwrite(qm,qi,g); fclose(g);
			i=md2treetype(qm);
			if (i==1) {
                		prverdstmp(); stringreplacechar(fn,' ','a');
                		g=fopen(fn,"w"); qmdwritecnf(mdnegate(qm),qi,g);
				fclose(g);
			} else if (i==2) {
                		prverdstmp(); stringreplacechar(fn,' ','e');
                		g=fopen(fn,"w"); qmdwritecnf(qm,qi,g);
				fclose(g);
			} 
			freeqmdata(qm); free(qi);
		}
		reportprogress(bv,k); if (r) mreturn(r);
	    }
	}
	mreturn(r);
}
/********************************************************************/
int satbmc(tree *spec,tree *prog,tree *fness,tree *varconstr,int booln)
{
	int i,k,r,bv;
	model *mm0;
	char fn[100];
	FILE *g;

	if (op0.opb.satsolver==NULL) { message("an internal SAT-solver"); }
	else if (strcmp(op0.opb.satsolver,"_")) { message(op0.opb.satsolver); }

	for (r=0,k=op0.opb.lbound;k<=op0.opb.bound;k++) {
	    for (bv=1;bv>=0;bv--) {
		if (tout) mreturn(r);
		mm0=bp2s(prog,varconstr,spec,booln,k,bv,0); 
		if (op0.opb.satsolver==NULL||strcmp(op0.opb.satsolver,"_")) {
			r=SOLVEapply(op0.opb.satsolver,mm0,bv); 
		} else {
                	prverdstmp(); stringreplacechar(fn,' ','0');
                	g=fopen(fn,"w"); cnfmodelwrite(mm0,g); fclose(g);
		}
		free(mm0->mstring); free(mm0); 
		reportprogress(bv,k); if (r) mreturn(r);
	    }
	}
	mreturn(r);
}
/********************************************************************/
int satbmcECTLx(tree *spec,tree *prog,tree *fness,tree *varconstr,int booln)
{
}
/********************************************************************/
void qmdwritecnf(qmdata *qm,qinfo *qi,FILE *g)
{
	model *mo;
	tree *t=md2tree(qm);
	t=treedopost(t,TLFnnf);
	t=treedopost(t,TLFnnfsimp);
	mo=CNFspec2model(t,qi->n); cnfmodelwrite(mo,g); 
	treefree(t); free(mo->mstring); free(mo); 
}
/********************************************************************/
model *qmd2model(qmdata *qm,qinfo *qi)
{
	model *mo;
	tree *t=md2tree(qm);
	t=treedopost(t,TLFnnf);
	t=treedopost(t,TLFnnfsimp);
	mo=CNFspec2model(t,qi->n); treefree(t);
	return mo;
}
/********************************************************************/
int checksolver(char *s,char *txt)
{
	if (s==NULL) return 0;
	else if (strcmp(s,"_")==0) return 1;
	else if (fileok(s)==0) return 0;
       	else { fprintf(stdout,"%s:  %s\n",txt,s); return 1; }
}
/********************************************************************/

/********************************************************************/
#define mreturn(r)	{ op0.bound=k; return r; }
#define prverdstmp()    { sprintf(fn,".verds_%i.%3i",bv,k); }
/********************************************************************/

/*******************************************************************/
int SOLVEapply(char *solver,model *mo,int bv)
{
	FILE *g;
	int r;

        if (solver==NULL||*solver=='_') r=SATapply(mo); 
	else {
       		g=fopen(tmp0file,"w"); cnfmodelwrite(mo,g); fclose(g);
		r=SOLVEapply_0(solver); if (r==-1) return 0;
	}
	if (bv&&r==0) return 1;
	if (!bv&&!r==0) return -1;
	return 0;
}
/*******************************************************************/
int SOLVEapply_0(char *solver)
{
	char *ll,*l0;
	char cmd[256];
	int r;
	int i;

	sprintf(cmd,"%s %s %s > %s",solver,tmp0file,tmp2file,tmp1file);
	i=system(cmd); i/=256;
	if (i==10) r=1; else if (i==20) r=0; else r=-1;
/*
	ll=file2string(tmp1file);
	l0=stringsearch(ll,"UNSAT","SATISFIABLE"); 
	switch (*l0) {
		case 'S': r=1; break;
		case 'U': r=0; break;
		case  0:  r=-1; break;
	}
	free(ll); 
*/
	return r;
}
/*******************************************************************/

/*******************************************************************/
int SOLVEapplyq(char *solver,qmdata *qm,qinfo *qi,int bv)
{
        FILE *g;
        int r;

        if (solver==NULL||*solver=='_') r=QBFapply(qi,qm); 
	else {
                g=fopen(tmp0file,"w"); 
		qmdwrite(qm,qi,g); fclose(g); freeqmdata(qm); free(qi);
                r=SOLVEapply_0(solver); 
		if (r==-1) return 0;
        }

	if (bv&r==1) return 1;
	if (!bv&r==1) return -1;
        return 0;
}
/*******************************************************************/
int qm2file(qmdata *qm,qinfo *qi,int bv,int k)
{
        FILE *f;
	char fn[100];
	char *f1;

	sprintf(fn,"qbf.%i%2i",bv,k); 
	f1=fn; for (;*f1;f1++) if (*f1==' ') *f1='0'; 
	f=fopen(fn,"w"); qmdwrite(qm,qi,f); fprintf(f,"\n"); fclose(f);
}
