#include <ctype.h>
#include <math.h>
#include "q0cnf.h"
#include "q1rd.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/resource.h>
#include <sys/times.h>
#include <time.h>

/*******************************************************************/
#define isLiteral(c)     (isdigit(c)||(c=='-'))
#define isNumbers(ll)	 ((strncmp(ll,"p cnf",5)==0))
#define moveLiteral(ll)  while (isLiteral(*ll)) ll++; 
#define moveNLiteral(ll) while (*ll&&!isLiteral(*ll)&&*ll!='\n') ll++;
/*******************************************************************/
void qmmodelwrite(qmodel *mo,FILE *g)
{
        int i;
        int *mstring=mo->mstring;
        int mstringc=mo->l;

        fprintf(g,"p cnf %i %i\n",mo->n,mo->m);
        for (i=0;i<mstringc;i++)
        if (mstring[i]) fprintf(g," %i ",mstring[i]);
        else fprintf(g," %i\n",mstring[i]);
}
/*******************************************************************/
void read_numbers(char *ll,qmodel *mm)
{
	int n,m,l;

	m=n=l=0;
	while (*ll) {
		if (*ll=='c') { while (*ll&&*ll!='\n') ll++; }
		else if (isNumbers(ll)) { break; }
		else ll++;
	}
	if (*ll) {
		moveNLiteral(ll); n=atoi(ll); moveLiteral(ll); 
		moveNLiteral(ll); m=atoi(ll); moveLiteral(ll); 
		moveNLiteral(ll); if (isLiteral(*ll)) l=atoi(ll); 
	}
	if (!(n>0&&m>0)) error("numbers required.");

	if (l==0) l=2*strlen(ll); 
	mm->n=n; mm->m=m; mm->l=l;
        mm->mstring=malloc(l*sizeof(int)); 
}
void read_clauses(char *ll,qmodel *mm)
{
        int i=0,j=0,k=0,len,n;
        int clen,c;
	int modm=mm->m;
	int modl=mm->l;
	int *p0=mm->mstring;
	
	while (*ll) {
		if (*ll=='c') { while (*ll&&*ll!='\n') ll++; }
		else if (isNumbers(ll)) { while (*ll&&*ll!='\n') ll++; break; }
		else ll++;
	}
	for (;;) {
		while (*ll&&(!isLiteral(*ll)||*ll=='0')) ll++;
		if (*ll==0) break;
                if (j==modm) error("too many clauses");
                for (clen=0,i=0;i<modl;i++) {
			c=atoi(ll); moveLiteral(ll); moveNLiteral(ll);
			if (!c) {
				n=remove_red(p0-clen,clen); 
				p0-=n; k-=n;
				if (clen>n) *p0++=c; else j--; break;
			}
        		if (k==modl) error("too many literals"); 
			k++; *p0++=c; clen++;
                }
                j++;
        }
	mm->m=j; mm->l=k+j; 
	mm->mstring=realloc(mm->mstring,mm->l*sizeof(int)); 
}
/************************************************************************/
int remove_red(int *p0,int k)
{
	int i,j;

	for (i=0;i<k;i++)
	for (j=i+1;j<k;j++) {
		if (p0[i]==p0[j]) { 
			p0[i]=p0[k-1]; p0[k-1]=0;
			return remove_red(p0,k-1)+1; 
		}
		if (p0[i]==-p0[j]) { return k; }
	}
	return 0;
}
int remove_red2(int *p0)
{
	int *p1=p0;
	int k;
	
	while (*p1) p1++; k=p1-p0;
	if (k==remove_red(p0,k)) return 0; return 1;
}
/************************************************************************/
void modelclean(qmodel *mm)
{
        int i;
	int *p0=mm->mstring;
	int *p2=mm->mstring;
	int m=0;
	int n,k;

	for (i=0;i<mm->m;i++) {
		k=0;
		while (*p0) { *p2++=*p0++; k++; }
		n=remove_red(p2-k,k);
		p2-=n; k-=n; if (k>0) { *p2++=0; m++; } 
		p0++;	/*zwh*/
	}
	mm->m=m;
	mm->l=p2-mm->mstring;
	mm->mstring=realloc(mm->mstring,mm->l*sizeof(int));
}
/************************************************************************/
int intin(int a,int *b,int x,int y)
{
	int i;
	for (i=x;i<=y;i++) if (a==b[i]) return i; return 0;
}
/************************************************************************/
int intlen(int *ss)
{
        int i=0;
	while (ss[i]) i++; return i;
}
/*******************************************************************/

/************************************************************************/
void freeqmdata(qmdata *md)
{
        if (md->q!=NULL) freeqmdata(md->q);
        if (md->next!=NULL) freeqmdata(md->next);
        if (md->Clause!=NULL) free(md->Clause); free(md);
}
/************************************************************************/
int qmdwrite(qmdata *md,qinfo *qi,FILE *g)
{
	fprintf(g,"QBF\n%i\n",qi->n); qmdwrite1(md,g,0); fprintf(g,"QBF\n"); 
}
int qmdwrite1(qmdata *md,FILE *g,int mode)
{
	int t0;
	if (md==NULL) return; t0=md->Clause[0];
	switch (t0) {
		case 'a': 
		case 'e': 
			if (mode!='q') fprintf(g,"q\n"); 
			fprintf(g,"%c ",t0); 
			intwrite(md->Clause+1,0,intlen(md->Clause+1)-1,g);
			qmdwrite1(md->q,g,'q');
			if (mode!='q') fprintf(g,"/q\n"); 
			break;
		case 'c': 
		case 'd': 
			fprintf(g,"%c\n",t0); 
			pnintwrite(md->Clause+1,g);
			qmdwrite1(md->q,g,0);
			for (;md->next!=NULL;md=md->next)
				qmdwrite1(md->next->q,g,0);
			fprintf(g,"/%c\n",t0); 
			break;
	}
}
/*******************************************************************/
void pnintwrite(int *ss,FILE *g)
{
        int i=0;
        for (i=0;ss[i];i++) if (ss[i]>0) { fprintf(g,"%i ",ss[i]); }
        fprintf(g,"\n");
        for (i=0;ss[i];i++) if (ss[i]<0) { fprintf(g,"%i ",-ss[i]); }
        fprintf(g,"\n");
}
/*******************************************************************/
#define single(md) \
	((md->q==NULL)&& \
	 (md->Clause[0]=='c'||md->Clause[0]=='d')&& \
	 (md->Clause[2]==0))
/************************************************************************/
void qmdsimp(qmdata *md,qinfo *qi)
{
	int t0;
	qmdata *md0; /* empty clauses are not considered */

	if (md==NULL) return; t0=md->Clause[0];
	switch (t0) {
	    case 'a': 
	    case 'e': 
		qmdsimp(md->q,qi); 
		break;
	    case 'c': 
	    case 'd': 
		while (md->q!=NULL) {
			if (md->q->Clause[0]==t0||single(md->q)) {
				qi->m--; qi->l-=2;
				mdmoveup1(md,md,md->q); continue;
			}
			qmdsimp(md->q,qi); break;
		}
		for (md0=md;md->next!=NULL;) {
			if (md->next->q==NULL) {
				free(md->next); md->next=NULL; break;
			}
			if (md->next->q->Clause[0]==t0||single(md->next->q)) {
				qi->m--; qi->l-=2;
				mdmoveup1(md0,md->next,md->next->q); 
				continue;
			}
			qmdsimp(md->next->q,qi); md=md->next;
		}
		break;
	}
}
/************************************************************************/
void mdmoveup1(qmdata *md0,qmdata *md,qmdata *mdq)
{
	qmdata *mdn=md->next;

	md0->Clause=mdintegrate(md0->Clause,mdq->Clause);

	if (mdq->q!=NULL) {
		md->q=mdq->q;
		md->next=mdq->next;
		while (md->next!=NULL) md=md->next; md->next=mdn;
		free(mdq->Clause); free(mdq);
	} else if (mdn!=NULL) {
		md->q=mdn->q; md->next=mdn->next; free(mdn);
		free(mdq->Clause); free(mdq);
	} else {
		free(mdq->Clause); free(mdq); 
		md->q=NULL;
	}
}

int *mdintegrate(int *a1,int *a2)
{
	int x=intlen(a1);
	int y=intlen(a2);
	int i;

	a1=(int *)realloc(a1,(x+y)*sizeof(int));
	for (i=1;i<=y;i++) a1[x+i-1]=a2[i]; return a1;
}
int qmdlen(qmdata *md)
{
	int k=0;

	if (md==NULL) return 0; 
	switch (md->Clause[0]) {
		case 'a': 
		case 'e': k=intlen(md->Clause+1)+1; k+=qmdlen(md->q)+1;
			  break;
		case 'c': 
		case 'd': k=intlen(md->Clause+1)+1; 
			  if (md->q==NULL) break; k+=qmdlen(md->q)+1; 
			  for (;md->next!=NULL;md=md->next)
			   	k+=qmdlen(md->next->q)+1;
			  break;
	}
	return k;
}
/*******************************************************************/
/*
int qmdm(qmdata *md)
{
	int k=0;

	if (md==NULL) return 0; 
	switch (md->Clause[0]) {
		case 'a': 
		case 'e': k+=qmdm(md->q)+1;
			  break;
		case 'c': 
		case 'd': k++; if (md->q==NULL) break; k+=qmdm(md->q); 
			  for (;md->next!=NULL;md=md->next)
			   	k+=qmdm(md->next->q);
			  break;
	}
	return k;
}
/*******************************************************************/
int qmdclauses(qmdata *md)
{
        int k=0;

        if (md==NULL) return 0;
        switch (md->Clause[0]) {
                case 'a':
                case 'e': k+=qmdclauses(md->q); break;
                case 'c':
                case 'd': if (md->q==NULL) break; k+=qmdclauses(md->q);
                          for (;md->next!=NULL;md=md->next)
                                k+=qmdclauses(md->next->q);
                          break;
        }
        return k+1;
}
/*******************************************************************/








/**********************************************************************/
void quicksort_abf(float *a,int *b,int l,int r) /* decreasing */
{
	float v,t0;
        int i,j,t1;
        if (r>l) {
                v=a[r]; i=l-1;j=r;
                for (;;) {
			for (i++;(a[i]>v);i++);
                        for (j--;j>=l&&(a[j]<v);j--); if (j<l) j=1;
/*
                        while (a[++i] > v); while (a[--j] < v);
*/
                        if (i>=j) break;
                        t0=a[i]; a[i]=a[j];a[j]=t0; t1=b[i]; b[i]=b[j];b[j]=t1;
                }
                t0=a[i]; a[i]=a[r];a[r]=t0;
                t1=b[i]; b[i]=b[r];b[r]=t1;
                quicksort_abf(a,b,l,i-1); quicksort_abf(a,b,i+1,r);
        }
}
/*******************************************************************/

/*******************************************************************/
void intwrite(int *ss,int a,int b,FILE *g)
{
        int i;
        for (i=a;i<=b;i++) fprintf(g,"%i ",ss[i]); fprintf(g,"\n");
}
/*******************************************************************/
void charwrite(char *ss,int a,int b,FILE *g)
{
        int i;
        for (i=a;i<=b;i++) fprintf(g,"%i ",ss[i]); fprintf(g,"\n");
}
/*******************************************************************/
void prettyintwrite(int *ss,int a,int b,FILE *g)
{
        int i,j;
        for (j=0,i=a;i<=b;i++) {
		fprintf(g,"%i ",ss[i]); 
		if (++j%10==0) fprintf(g,"\n");
	}
	fprintf(g,"\n");
}
/*******************************************************************/
void cnfstringwrite(int *mstring,int mstringc,FILE *g)
{
        int i;
        for (i=0;i<mstringc;i++)
        if (mstring[i]) fprintf(g," %i ",mstring[i]);
        else fprintf(g," %i\n",mstring[i]);
}
/*******************************************************************/
